package de.arindy.mythodea.api

import jakarta.inject.Inject
import jakarta.ws.rs.GET
import jakarta.ws.rs.Path
import jakarta.ws.rs.Produces
import jakarta.ws.rs.QueryParam
import jakarta.ws.rs.core.MediaType
import java.time.Instant

@Path("date/")
class GreetingResource @Inject constructor(var repository: Repository) {

    @GET
    @Path("from")
    @Produces(MediaType.APPLICATION_JSON)
    fun from(@QueryParam("epochMillis") epochMillis: Long): MitrasperanDate =
        mitrasperan(if (epochMillis > 0) Instant.ofEpochMilli(epochMillis) else Instant.now())
}
