package de.arindy.mythodea.api

import io.quarkus.logging.Log
import java.time.Instant
import java.util.Calendar
import java.util.Date
import java.util.TimeZone

data class MitrasperanDate internal constructor(
    val day: Int,
    val month: Int,
    val year: Int,
    private val gregorianMonth: Int,
    val yearNDE: Int = if (month <= 6 || gregorianMonth >= 7) year + 1 else year,
    val yearNDK: Int = year - 19,
    val dayString: String = DAYS[day - 1],
    val monthString: String = MONTHS[month - 1]
) {

    constructor(day: Int, month: Int, year: Int) : this(day, month, year, -1)

    companion object {
        private val MONTHS = arrayOf(
            "Wandelmond",
            "Launing",
            "Blütenmond",
            "Brachmond",
            "Weidmond",
            "Naiba",
            "Holzmond",
            "Goldmond",
            "Scheiding",
            "Blaumond",
            "Gilbhart",
            "Eismond",
            "Fralt",
        )
        private val DAYS = arrayOf(
            "1. Erztag",
            "1. Fyrstag",
            "1. Bindetag",
            "1. Meerstag",
            "1. Wintstag",
            "1. Mahntag",
            "2. Erztag",
            "2. Fyrstag",
            "2. Bindetag",
            "2. Meerstag",
            "2. Wintstag",
            "2. Mahntag",
            "Weiße Vornacht",
            "Weiße Nacht",
            "Weiße Nacht",
            "3. Erztag",
            "3. Fyrstag",
            "3. Bindetag",
            "3. Meerstag",
            "3. Wintstag",
            "3. Mahntag",
            "4. Erztag",
            "4. Fyrstag",
            "4. Bindetag",
            "4. Meerstag",
            "4. Wintstag",
            "4. Mahntag",
            "Schwarze Nacht",
            "Schwarze Nacht",
            "Pechnacht",
        )
    }
}

fun mitrasperan(date: Instant): MitrasperanDate {
    val calendar = Calendar.getInstance(TimeZone.getTimeZone("Europe/Berlin"))
    calendar.time = Date.from(date)
    Log.info(calendar.time.toString())
    return MitrasperanCalendar().get(calendar)
}
